Last Comment Bug 802396 - Android Service-based updater downloads wrong architecture update package for ARMv6.
: Android Service-based updater downloads wrong architecture update package for...
Status: RESOLVED FIXED
[ARMv6][Updater]
:
Product: Firefox for Android
Classification: Client Software
Component: General (show other bugs)
: 19 Branch
: ARM Android
: -- major (vote)
: Firefox 19
Assigned To: James Willcox (:snorp) (jwillcox@mozilla.com)
:
Mentors:
Depends on:
Blocks: 786380
  Show dependency treegraph
 
Reported: 2012-10-16 15:33 PDT by Szabolcs Hubai (:xabolcs)
Modified: 2012-10-29 07:48 PDT (History)
4 users (show)
ryanvm: in‑testsuite-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
fixed
fixed


Attachments
ARMv6 Nightly updated to ARMv7 couldn't load mozglue (2.47 KB, text/plain)
2012-10-16 15:38 PDT, Szabolcs Hubai (:xabolcs)
no flags Details
Use the correct update url for Android ARMv6 (1.05 KB, patch)
2012-10-17 08:54 PDT, James Willcox (:snorp) (jwillcox@mozilla.com)
blassey.bugs: review+
akeybl: approval‑mozilla‑aurora+
lukasblakk+bugs: approval‑mozilla‑beta+
Details | Diff | Splinter Review

Description Szabolcs Hubai (:xabolcs) 2012-10-16 15:33:35 PDT
STR:

0. $ ./adb logcat |grep -e "/GeckoApp" -e "/UpdateService"
1. get an outdated Nightly for Android ARMv6 (for example 2012-10-15 [1])
2. check for update
3. examine the log

> I/GeckoApp(17715): Got message: Update:Check
> I/GeckoApp(17715): Return
> I/UpdateService(16977): next update will be at: Wed Oct 17 02:51:50 GMT+02:00 2012
> I/UpdateService(16977): update available, buildID = 20121016030544
> I/UpdateService(16977): downloading update package
> I/UpdateService(16977): completed update download!
> I/UpdateService(16977): have update package at /mnt/sdcard/Download/fennec-19.0a1.multi.android-arm.apk

4. examine the downloaded apk: 
4.1: it have "lib/armeabi-v7a" directory, instead "lib/armeabi" 
4.2: it's name doesn't have "-armv6" suffix.

5. if You install the downloaded update, the updated Nightly will hang (as expected): "force close / wait" popup appears




[1]: https://ftp.mozilla.org/pub/mozilla.org/mobile/nightly/2012/10/2012-10-15-03-06-12-mozilla-central-android-armv6/fennec-19.0a1.multi.android-arm-armv6.apk
Comment 1 Szabolcs Hubai (:xabolcs) 2012-10-16 15:38:54 PDT
Created attachment 672065 [details]
ARMv6 Nightly updated to ARMv7 couldn't load mozglue

ADB logcat-ed start-up of updated Nightly.

> E/GeckoAppShell(18721): >>> REPORTING UNCAUGHT EXCEPTION FROM THREAD 1 ("main")
> E/GeckoAppShell(18721): java.lang.UnsatisfiedLinkError: Couldn't load mozglue: findLibrary returned null

Of course, this (v7 binary can't run on v6) is not a surprise.
Comment 2 Szabolcs Hubai (:xabolcs) 2012-10-16 15:45:24 PDT
Forgot to mention the hardware.

Memory: 280M
Hardware: Samsung Galaxy Mini (GT-S5570)


> $ busybox free
>               total         used         free       shared      buffers
>   Mem:       286620       268568        18052            0          740
>  Swap:            0            0            0
> Total:       286620       268568        18052
> 
> $ cat /proc/cpuinfo
> Processor       : ARMv6-compatible processor rev 5 (v6l)
> BogoMIPS        : 599.65
> Features        : swp half thumb fastmult vfp edsp java
> CPU implementer : 0x41
> CPU architecture: 6TEJ
> CPU variant     : 0x1
> CPU part        : 0xb36
> CPU revision    : 5
> 
> Hardware        : GT-S5570 Board
> Revision        : 0003
> Serial          : xxxxxxxxxxxxxxxxxxxxx
Comment 3 James Willcox (:snorp) (jwillcox@mozilla.com) 2012-10-17 08:54:16 PDT
Created attachment 672333 [details] [diff] [review]
Use the correct update url for Android ARMv6
Comment 4 James Willcox (:snorp) (jwillcox@mozilla.com) 2012-10-18 07:19:37 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/87d06105d0ba
Comment 5 Ryan VanderMeulen [:RyanVM] 2012-10-18 18:41:23 PDT
https://hg.mozilla.org/mozilla-central/rev/87d06105d0ba
Comment 6 James Willcox (:snorp) (jwillcox@mozilla.com) 2012-10-19 10:10:23 PDT
Comment on attachment 672333 [details] [diff] [review]
Use the correct update url for Android ARMv6

[Approval Request Comment]
No risk, fixes updater for ARMv6
Comment 7 Alex Keybl [:akeybl] 2012-10-19 16:01:49 PDT
Comment on attachment 672333 [details] [diff] [review]
Use the correct update url for Android ARMv6

Product expressed a desire to possibly use the FF17 updater off of the ESR branch. Can we uplift there as well?
Comment 8 James Willcox (:snorp) (jwillcox@mozilla.com) 2012-10-22 11:28:05 PDT
Comment on attachment 672333 [details] [diff] [review]
Use the correct update url for Android ARMv6

[Approval Request Comment]
Low-risk, makes updater work for ARMv6 on Beta
Comment 9 James Willcox (:snorp) (jwillcox@mozilla.com) 2012-10-22 11:30:56 PDT
https://hg.mozilla.org/releases/mozilla-aurora/rev/d9d6459ef4dd
Comment 10 James Willcox (:snorp) (jwillcox@mozilla.com) 2012-10-22 13:02:36 PDT
https://hg.mozilla.org/releases/mozilla-beta/rev/d784c1e0cfad
Comment 11 Ben Hearsum (:bhearsum) 2012-10-29 07:48:09 PDT
I'm pretty sure this caused updates for armv7 to break :(. bug 806343 has some analysis.

Note You need to log in before you can comment on or make changes to this bug.